osl::checkmate Namespace Reference

## Classes

class | King8Info
| 敵玉の8近傍の状態を表す. More...
struct | NoProofPieces
class | FixedDepthSearcher
| 深さ固定で，その深さまで depth first searchで読む詰将棋. More...
class | ImmediateCheckmate
class | ImmediateCheckmateTable
class | ProofDisproof
| 証明数(proof number)と反証数(disproof number). More...
struct | CheckmateIfCapture
struct | SimpleTwinList
struct | DfpnPathRecord
struct | DfpnVisitLock
struct | DfpnPathList
class | DfpnPathTable
class | DfpnTable
| 詰探索局面表 – 並列でも共有する部分 More...
class | Dfpn
| 詰探索 More...
class | DfpnShared
struct | DfpnRecordBase
class | DfpnRecord
struct | DisproofPieces
class | DualDfpn
| 一般用詰み探索: 先手後手の詰みを別々に管理 More...
class | FixedDepthSolverExt
struct | PureLibertyEstimator
struct | LibertyEstimator
| 玉の動ける場所を基本としたHの推定. More...
struct | OracleAdjust
struct | PawnCheckmateMoves
struct | PieceCost
| 駒の損得に基づいたcostの推定 More...
class | ProofNumberTable
class | EdgeTable
struct | ProofPieces
struct | ProofPiecesUtil
| ProofPieces と DisproofPieces に共通の関数 More...
class | ProofTreeDepthDfpn
| 詰までの手数を数える. More...

## Enumerations

enum | LoopToDominance { NoLoop =0 , BadAttackLoop }

## Functions

std::ostream & | operator<< (std::ostream &, King8Info)
bool | operator== (const ProofDisproof &l, const ProofDisproof &r)
bool | operator!= (const ProofDisproof &l, const ProofDisproof &r)
bool | operator< (const ProofDisproof &l, const ProofDisproof &r)
std::ostream & | operator<< (std::ostream &os, const ProofDisproof &proofDisproof)
int | log2 (uint32_t n)
int | slow_increase (uint32_t n)
int | attackProofCost (Player attacker, const NumEffectState &state, Move move)

## Variables

const ImmediateCheckmateTable | Immediate_Checkmate_Table
ProofNumberTable | Proof_Number_Table
EdgeTable | Edge_Table

## Enumeration Type Documentation

## LoopToDominance

enum osl::checkmate::LoopToDominance

Enumerator
NoLoop |
BadAttackLoop |

Definition at line 182 of file dfpn.cc.

## Function Documentation

## attackProofCost()

int osl::checkmate::attackProofCost | ( | Player | attacker,
|  | const NumEffectState & | state,
|  | Move | move )

Definition at line 313 of file dfpn.cc.

References osl::alt(), osl::checkmate::PieceCost::attack_sacrifice_cost, osl::NumEffectState::countEffect(), osl::Move::from(), osl::Move::isCapture(), osl::Square::isPieceStand(), osl::Move::ptype(), and osl::Move::to().

Referenced by osl::checkmate::Dfpn::attack().

## log2()

int osl::checkmate::log2 | ( | uint32_t | n | ) |

inline

Definition at line 100 of file dfpn.cc.

Referenced by slow_increase().

## operator!=()

bool osl::checkmate::operator!= | ( | const ProofDisproof & | l,
|  | const ProofDisproof & | r )

inline

Definition at line 144 of file proofDisproof.h.

## operator<()

bool osl::checkmate::operator< | ( | const ProofDisproof & | l,
|  | const ProofDisproof & | r )

inline

Definition at line 148 of file proofDisproof.h.

References osl::checkmate::ProofDisproof::ulonglongValue().

## operator<<() [1/2]

std::ostream & osl::checkmate::operator<< | ( | std::ostream & | os,
|  | King8Info | info )

Definition at line 10 of file king8Info.cc.

References osl::checkmate::King8Info::dropCandidate(), osl::checkmate::King8Info::liberty(), osl::checkmate::King8Info::libertyCandidate(), and osl::checkmate::King8Info::moveCandidate2().

## operator<<() [2/2]

std::ostream & osl::checkmate::operator<< | ( | std::ostream & | os,
|  | const ProofDisproof & | proofDisproof )

Definition at line 11 of file proofDisproof.cc.

References osl::checkmate::ProofDisproof::AttackBack(), osl::checkmate::ProofDisproof::Checkmate(), osl::checkmate::ProofDisproof::disproof(), osl::checkmate::ProofDisproof::LoopDetection(), osl::checkmate::ProofDisproof::NoCheckmate(), osl::checkmate::ProofDisproof::NoEscape(), osl::checkmate::ProofDisproof::PawnCheckmate(), and osl::checkmate::ProofDisproof::proof().

## operator==()

bool osl::checkmate::operator== | ( | const ProofDisproof & | l,
|  | const ProofDisproof & | r )

inline

Definition at line 140 of file proofDisproof.h.

References osl::checkmate::ProofDisproof::ulonglongValue().

## slow_increase()

int osl::checkmate::slow_increase | ( | uint32_t | n | ) |

inline

Definition at line 104 of file dfpn.cc.

References log2().

Referenced by osl::checkmate::Dfpn::attack(), and osl::checkmate::Dfpn::defense().

## Variable Documentation

## Edge_Table

osl::checkmate::EdgeTable osl::checkmate::Edge_Table

extern

Definition at line 11 of file proofNumberTable.cc.

Referenced by osl::checkmate::Dfpn::attack(), and osl::checkmate::FixedDepthSolverExt::SetProofPieces::attackEstimation().

## Immediate_Checkmate_Table

const checkmate::ImmediateCheckmateTable osl::checkmate::Immediate_Checkmate_Table

extern

Definition at line 122 of file tables.cc.

Referenced by osl::move_probability::StateInfo::clearOldCache(), and osl::move_probability::StateInfo::findCheckmateDefender().

## Proof_Number_Table

osl::checkmate::ProofNumberTable osl::checkmate::Proof_Number_Table

extern

Definition at line 10 of file proofNumberTable.cc.

Referenced by osl::checkmate::FixedDepthSolverExt::SetProofPieces::attackEstimation(), and osl::checkmate::PureLibertyEstimator::attackH().